import _regeneratorRuntime from "@babel/runtime/regenerator";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import { take, put, select } from 'redux-saga/effects';
import getHash from './get_hash';
import { lastTimestampMap } from './constants';
import { CONNECT_VIEWMODEL, DISPATCH_TOPIC_MESSAGE } from './action_types';
import unsubscribeViewModelTopicsSaga from './unsubscribe_view_model_topics_saga';

var eventListenerSaga =
/*#__PURE__*/
_regeneratorRuntime.mark(function eventListenerSaga(_ref, connectAction) {
  var viewModels, sagaKey, sagaManager, eventTypes, store, _ref2, event, _ref3, viewModelLastTimestampMap, key, lastTimestamp;

  return _regeneratorRuntime.wrap(function eventListenerSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          viewModels = _ref.viewModels, sagaKey = _ref.sagaKey, sagaManager = _ref.sagaManager, eventTypes = _ref.eventTypes, store = _ref.store;

        case 1:
          if (!true) {
            _context.next = 26;
            break;
          }

          _context.next = 4;
          return take(function (action) {
            return action.type === DISPATCH_TOPIC_MESSAGE && eventTypes.indexOf(action.message.type) > -1 && (connectAction.aggregateIds === '*' || connectAction.aggregateIds.indexOf(action.message.aggregateId) > -1);
          });

        case 4:
          _ref2 = _context.sent;
          event = _ref2.message;
          _context.next = 8;
          return select();

        case 8:
          _ref3 = _context.sent;
          viewModelLastTimestampMap = _ref3.viewModels[lastTimestampMap];
          key = "" + connectAction.viewModelName + getHash(connectAction.aggregateIds) + getHash(connectAction.aggregateArgs);
          lastTimestamp = viewModelLastTimestampMap[key];

          if (!(event.timestamp >= lastTimestamp)) {
            _context.next = 24;
            break;
          }

          _context.prev = 13;
          _context.next = 16;
          return put(event);

        case 16:
          viewModelLastTimestampMap[key] = event.timestamp;
          _context.next = 24;
          break;

        case 19:
          _context.prev = 19;
          _context.t0 = _context["catch"](13);
          // eslint-disable-next-line no-console
          console.warn(_context.t0);
          return _context.delegateYield(unsubscribeViewModelTopicsSaga({
            viewModels: viewModels,
            viewModelName: connectAction.viewModelName,
            aggregateIds: connectAction.aggregateIds
          }), "t1", 23);

        case 23:
          return _context.delegateYield(sagaManager.stop("" + CONNECT_VIEWMODEL + sagaKey, function () {
            return store.dispatch(_objectSpread({}, connectAction, {
              skipConnectionManager: true
            }));
          }), "t2", 24);

        case 24:
          _context.next = 1;
          break;

        case 26:
        case "end":
          return _context.stop();
      }
    }
  }, eventListenerSaga, this, [[13, 19]]);
});

export default eventListenerSaga;
//# sourceMappingURL=event_listener_saga.js.map